﻿<#
    .NOTES
    --------------------------------------------------------------------------------
     Code generated by:  SAPIEN Technologies, Inc., PowerShell Studio 2018 v5.5.148
     Generated on:       3/14/2018 3:15 PM
     Generated by:        Ben Claussen
     Organization:       NEOnet
    --------------------------------------------------------------------------------
    .DESCRIPTION
        Script generated by PowerShell Studio 2018
#>


#region Invoke-Helpers_ps1
	<#	
		.NOTES
		===========================================================================
		 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2017 v5.4.138
		 Created on:   	5/1/2017 11:43 AM
		 Created by:   	Ben Claussen
		 Organization: 	NEOnet
		 Filename:     	Helpers.ps1
		===========================================================================
		.DESCRIPTION
			A description of the file.
	#>
	
	function CheckCherwellIsConnected {
		[CmdletBinding()]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if ((-not $script:CherwellConfig) -or (-not $script:CherwellConfig.Connected)) {
			throw "Not connected to a Cherwell API! Please run 'Connect-CherwellAPI'"
		}
		
		return $true
	}
	
	function BuildNewURI {
	<#
		.SYNOPSIS
			Create a new URI
		
		.DESCRIPTION
			Create a [System.UriBuilder] for easy URI manipulation.
		
		.PARAMETER Hostname
			Hostname of the API
		
		.PARAMETER Port
			Port number on which the web service is provided. Defaults to 443
		
		.PARAMETER Segments
			Array of strings for each segment in the URL path
		
		.PARAMETER Parameters
			Hashtable of query parameters to include
		
		.PARAMETER HTTPS
			Whether to use HTTPS or HTTP. Defaults to TRUE. You must explicitly disable HTTPS by setting this to FALSE. False is a bad idea.
		
		.PARAMETER TokenRequest
			Generate a token request.
		
		.PARAMETER V2
			Use version 2 of the API.
		
		.EXAMPLE
			PS C:\> BuildNewURI
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([System.UriBuilder])]
		param
		(
			[Parameter(Mandatory = $false)]
			[string]$Hostname,
			
			[Parameter(Mandatory = $false)]
			[uint16]$Port = 443,
			
			[Parameter(Mandatory = $false)]
			[string[]]$Segments,
			
			[Parameter(Mandatory = $false)]
			[AllowNull()]
			[hashtable]$Parameters,
			
			[Parameter(Mandatory = $false)]
			[boolean]$HTTPS = $true,
			
			[Parameter(Mandatory = $false)]
			[switch]$TokenRequest = $false,
			
			[switch]$V2
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if (-not $Hostname) {
			$Hostname = Get-CherwellHostname
		}
		
		if (-not $HTTPS) {
			Write-Warning "Using HTTP is insecure and credentials are passed in clear text. Please consider utilizing HTTPS."
		}
		
		# Begin a URI builder with HTTP/HTTPS and the provided hostname
		$uriBuilder = [System.UriBuilder]::new($(if ($HTTPS) {'https'} else {'http'}), $Hostname, $port)
		
		if ($TokenRequest) {
			# Requesting a token uses a different path from the regular API
			$uriBuilder.Path = "CherwellAPI/token"
			Write-Verbose "This is a token URI... using $($uriBuilder.Path)"
		} else {
			# Generate the path by trimming excess slashes and whitespace from the $segments[] and joining together
			$uriBuilder.Path = "CherwellAPI/api/{0}/{1}" -f $(if ($V2) {'v2'} else {'v1'}), ($Segments.ForEach({$_.trim('/').trim()}) -join '/')
			Write-Verbose "This is a normal URI... using $($uriBuilder.Path)"
		}
		
		if ($parameters) {
			Write-Debug "Adding parameters to URIBuilder"
			# Loop through the parameters and use the HttpUtility to create a Query string
			$URIParams = [System.Web.HttpUtility]::ParseQueryString([String]::Empty)
			
			foreach ($param in $Parameters.GetEnumerator()) {
				$URIParams[$param.Key] = $param.Value
				Write-Debug "Added $($param.Key):$($param.Value)"
			}
			
			$uriBuilder.Query = $URIParams.ToString()
		}
		
		# Return the entire UriBuilder object
		$uriBuilder
	}
	
	function AutoRefreshCherwellAccessToken {
		[CmdletBinding()]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if ($script:CherwellConfig.Token.Expires -lt (Get-Date)) {
			Write-Verbose "The token has expired"
			
			if ($script:CherwellConfig.AutoRefreshToken -eq $true) {
				# We are set to automatically refresh
				Write-Warning "Automatically refreshing token"
				SetCherwellConfigToken -Token (Get-CherwellToken)
			} else {
				throw "Token expired at $($script:CherwellConfig.Token.Expires) and AutoRefresh is disabled"
			}
		} else {
			Write-Verbose "Token is still valid for $('{0:n2}' -f ($script:CherwellConfig.Token.Expires - (Get-Date)).TotalMinutes) minutes"
			return $true
		}
	}
	
	function InvokeCherwellRequest {
	<#
		.SYNOPSIS
			Internal function. Sends an HTTP request to Cherwell
		
		.DESCRIPTION
			Generates a proper HTTP request including headers and body to send to a Cherwell server
		
		.PARAMETER URI
			A System.UriBuilder object which will generate the full URL including scheme, hostname, path, and parameters
		
		.PARAMETER Headers
			A System.Hashtable object which will be converted to the HTTP headers sent to the server
		
		.PARAMETER Body
			A System.Hashtable of parameters which will be sent as a JSON body to the server
		
		.PARAMETER Timeout
			The time in seconds for Invoke-RestMethod to give up without receiving a response from the server. The default is determined by Get-CherwellAPITimeout. A value of 0 will set it to a maximum timeout.
		
		.PARAMETER Method
			The HTTP method to use for the request. Defaults to GET
		
		.PARAMETER ContentType
			The content type header sent to the server. Defaults to 'application/json'
		
		.PARAMETER BypassAuthorizationHeader
			Skip the check for the Authorization Header. Generally only used for a token request
		
		.PARAMETER TokenRequest
			Determines whether this is a token request which requires a different base path.
		
		.EXAMPLE
			PS C:\> InvokeCherwellRequest -URI $value1
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding(SupportsShouldProcess = $true)]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true)]
			[System.UriBuilder]$URI,
			
			[Hashtable]$Headers = @{ },
			
			[hashtable]$Body = $null,
			
			[AllowNull()]
			[System.Nullable[int32]]$Timeout,
			
			[ValidateSet('GET', 'PATCH', 'PUT', 'POST', 'DELETE', IgnoreCase = $true)]
			[string]$Method = 'GET',
			
			[ValidateSet('application/json', 'application/x-www-form-urlencoded', IgnoreCase = $true)]
			[string]$ContentType = "application/json",
			
			[switch]$BypassAuthorizationHeader,
			
			[switch]$TokenRequest
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		Write-Verbose "Building request invocation..."
		
		# Determine if we need to obtain the timeout value or set it to maximum
		if ($Timeout -eq $null) {
			$Timeout = Get-CherwellAPITimeout
			Write-Verbose "Timeout not provided.. Setting timeout to config variable default: $Timeout"
		} elseif ($Timeout -eq 0) {
			Write-Warning "Timeout value set to maximum!"
			$Timeout = [int32]::MaxValue
		}
		
		if ($TokenRequest) {
			Write-Verbose "Skipping authorization header check"
			$BypassAuthorizationHeader = $true
		} else {
			$null = AutoRefreshCherwellAccessToken -ErrorAction Stop
		}
		
		if (-not $BypassAuthorizationHeader) {
			# We are NOT bypassing the authorization header check
			if (-not $Headers.Authorization) {
				# Add the Authorization header if it does not exist
				Write-Verbose 'Adding authorization to headers'
				$null = $Headers.Add('Authorization', ("Bearer {0}" -f (GetCherwellConfigToken).AccessToken))
			}
		}
		
		$splat = @{
			'Method' = $Method
			'Uri' = $URI.Uri.AbsoluteUri # This property auto generates the scheme, hostname, path, and query
			'Headers' = $Headers
			'TimeoutSec' = $Timeout
			'ContentType' = $ContentType
			'ErrorAction' = 'Stop'
			'Verbose' = $VerbosePreference
		}
		
		if ($Body) {
			if ($ContentType -eq 'application/json') {
				Write-Verbose "Converting body to JSON"
				$null = $splat.Add('Body', ($Body | ConvertTo-Json -Compress))
				Write-Verbose "JSON Body: $($splat.Body)"
			} else {
				Write-Verbose "Using x-www-form-urlencoded body"
				$null = $splat.Add('Body', $Body)
			}
			
			# Pretty hashtable verbose output
			$columnWidth = $body.Keys.length | Sort-Object | Select-Object -Last 1
			Write-Verbose "Body hashtable:"
			$Body.GetEnumerator() | ForEach-Object {
				if ($_.Key -eq 'password') {
					Write-Verbose ("  {0,-$columnWidth} : {1}" -F $_.Key, '***HIDDEN***')
				} else {
					Write-Verbose ("  {0,-$columnWidth} : {1}" -F $_.Key, $_.Value)
				}
			}
		}
		
		if (($Method -eq 'POST') -and $Body) {
			Write-Verbose "A -1-byte payload is expected in the verbose output below!"
		}
		
		$timestamp = (Get-Date)
		$results = Invoke-RestMethod @splat
		Write-Verbose "Response received and parsed in $((Get-Date) - $timestamp)"
		
		$results
	}
	
	function Invoke-CherwellRequestFromURL {
		[CmdletBinding()]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipeline = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string[]]$Url,
			
			[Hashtable]$Headers = @{},
			
			[hashtable]$Body = $null,
			
			[AllowNull()]
			[int32]$Timeout,
			
			[ValidateSet('GET', 'PATCH', 'PUT', 'POST', 'DELETE', IgnoreCase = $true)]
			[string]$Method = 'GET',
			
			[ValidateSet('application/json', 'application/x-www-form-urlencoded', IgnoreCase = $true)]
			[string]$ContentType = "application/json"
		)
		
		BEGIN {	}
		
		PROCESS {
			foreach ($u in $Url) {
				Write-Verbose "Invoking request for $u"
				InvokeCherwellRequest -URI ([System.UriBuilder]::new($u)) -Headers $Headers -Body $Body -Timeout $Timeout -Method $Method -ContentType $ContentType
			}
		}
		
		END { }
	}
	
	
	function CompareValue {
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[string]$Value1,
			
			[Parameter(Mandatory = $true,
					   Position = 1)]
			[string]$Operator,
			
			[Parameter(Mandatory = $true,
					   Position = 2)]
			[string]$Value2
		)
		
		#Write-Verbose "COMPARE: $Value1 $Operator $Value2"
		
		switch ($Operator) {
			'Match' {
				return $Value1 -match $Value2
			}
			
			'Like' {
				return $Value1 -like $Value2
			}
			
			'NotLike' {
				return $Value1 -notlike $Value2
			}
			
			'Equal' {
				return $Value1 -eq $Value2
			}
			
			'NotEqual' {
				return $Value1 -ne $Value2
			}
			
			'StartsWith' {
				return $Value1 -like "$($Value2.TrimStart('*').TrimEnd('*'))*"
			}
			
			default {
				throw "Operator '$Operator' not supported."
			}
		}
	}
	
	function VerifyIDLength {
	<#
		.SYNOPSIS
			Verifies the length of a BO/Rec ID
		
		.DESCRIPTION
			A detailed description of the VerifyIDLength function.
		
		.PARAMETER Id
			The ID to verify
		
		.EXAMPLE
			PS C:\> VerifyIDLength -Id 'Value1'
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([boolean])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipeline = $true,
					   Position = 0)]
			[string[]]$Id
		)
		
		Begin {
			# All Cherwell BO and Rec IDs are 42 characters.
			$validLength = 42
		}
		
		Process {
			foreach ($str in $id) {
				$validId = $str.Length -eq $validLength
				Write-Verbose "ID is valid: $validId"
				$validId
			}
		}
		
		End {
			
		}
	}
	
	
	function ProcessWebRequestException {
		[CmdletBinding()]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[System.Management.Automation.ErrorRecord]$Error
		)
		
		if ($Error.Exception.Response) {
			[System.Net.HttpWebResponse]$response = $Error.Exception.Response
			
			if ($Error.ErrorDetails.Message -match "The Business Object is not configured for searching") {
				return "The Business Object is not configured for searching"
			}
			
		}
	}
	
	
	
	
	
	
	#endregion

#region Invoke-Setup_ps1
	<#	
		.NOTES
		===========================================================================
		 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2017 v5.4.138
		 Created on:   	5/1/2017 11:44 AM
		 Created by:   	 Ben Claussen
		 Organization: 	NEOnet
		 Filename:     	Setup.ps1
		===========================================================================
		.DESCRIPTION
			A description of the file.
	#>
	
	function SetupCherwellConfigVariable {
		[CmdletBinding()]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		Write-Verbose "Checking for CherwellConfig hashtable"
		if (-not ($script:CherwellConfig)) {
			Write-Verbose "Creating CherwellConfig hashtable"
			$script:CherwellConfig = [hashtable]@{
				'Connected' = $false
				'CachedData' = [hashtable]@{
					'BusinessObjects' = [hashtable]@{
						'Summaries' = $null
					}
					
					'SearchItems' = [hashtable]@{
						'SupportedAssociations' = [hashtable]@{
							
						}
						'SearchItems' = $null
					}
				}
			}
		}
		
		Write-Verbose "CherwellConfig hashtable already exists"
	}
	
	function GetCherwellConfigVariable {
		[CmdletBinding()]
		param
		(
			[switch]$Create
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		Write-Verbose "Checking for CherwellConfig hashtable"
		if (-not $script:CherwellConfig) {
			Write-Verbose "CherwellConfig hashtable does not exist..."
			if (-not $Create) {
				throw "CherwellConfigVariable does not exist!"
			} else {
				SetupCherwellConfigVariable
			}
		} else {
			Write-Verbose "CherwellConfig hashtable exists!"
			return $script:CherwellConfig
		}
	}
	
	#region Caching functions - Unused
	
	function InstantiateCherwellCache {
	<#
		.SYNOPSIS
			Creates the necessary cached data in the CherwellConfig variable
		
		.DESCRIPTION
			A detailed description of the InstantiateCherwellCache function.
		
		.PARAMETER GetBusinessObjectSummaries
			A description of the GetBusinessObjectSummaries parameter.
		
		.PARAMETER BusinessObjectSummaries
			A description of the BusinessObjectSummaries parameter.
		
		.PARAMETER GetSearchItems
			A description of the GetSearchItems parameter.
		
		.PARAMETER SearchItems
			A description of the SearchItems parameter.
		
		.PARAMETER GetBusinessObjectSummaries
			A description of the GetBusinessObjectSummaries parameter.
		
		.PARAMETER GetSearchItems
			A description of the GetSearchItems parameter.
		
		.EXAMPLE
			PS C:\> InstantiateCherwellCache
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		param
		(
			[switch]$GetBusinessObjectSummaries,
			
			[object[]]$BusinessObjectSummaries,
			
			[switch]$GetSearchItems,
			
			[object[]]$SearchItems
		)
		
		if ($GetBusinessObjectSummaries) {
			if ($BusinessObjectSummaries) {
				Write-Verbose "Caching BusinessObjectSummaries from provided object"
				$script:CherwellConfig['CachedData']['BusinessObjects']['Summaries'] = $BusinessObjectSummaries
			} else {
				Write-Verbose "Caching BusinessObjectSummaries from API calls"
				# Get the object summaries from the API and stash it in the config
			}
		}
		
		if ($GetSearchItems) {
			
		}
	}
	
	function GetCherwellCache {
		[CmdletBinding(DefaultParameterSetName = 'BusinessObjectSummaries')]
		param
		(
			[Parameter(ParameterSetName = 'BusinessObjectSummaries',
					   Mandatory = $true)]
			[switch]$BusinessObjectSummaries,
			
			[Parameter(ParameterSetName = 'SearchItems',
					   Mandatory = $true)]
			[switch]$SearchItems
		)
		
		switch ($PSCmdlet.ParameterSetName) {
			'BusinessObjectSummaries' {
				return $script:CherwellConfig['CachedData']['BusinessObjects']['Summaries']
			}
			
			'SearchItems' {
				return $script:CherwellConfig['CachedData']['SearchItems']['SearchItems']
			}
			
			default {
				#<code>
			}
		}
	}
	
	#endregion Caching functions - Unused
	
	function Set-CherwellHostName {
		[CmdletBinding()]
		param
		(
			[Parameter(Mandatory = $true)]
			[ValidateNotNullOrEmpty()]
			[string]$Hostname
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$script:CherwellConfig.Hostname = $Hostname.Trim()
		$script:CherwellConfig.Hostname
	}
	
	function Get-CherwellHostname {
		[CmdletBinding()]
		[OutputType([string])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if ($script:CherwellConfig.Hostname -eq $null) {
			throw "Cherwell Hostname is not set! You may set it with Set-CherwellHostname -Hostname 'hostname.domain.tld'"
		}
		
		$script:CherwellConfig.Hostname
	}
	
	function Set-CherwellCredentials {
		[CmdletBinding(DefaultParameterSetName = 'CredsObject')]
		[OutputType([pscredential], ParameterSetName = 'CredsObject')]
		[OutputType([pscredential], ParameterSetName = 'UserPass')]
		param
		(
			[Parameter(ParameterSetName = 'CredsObject',
					   Mandatory = $true)]
			[pscredential]$Credentials,
			
			[Parameter(ParameterSetName = 'UserPass',
					   Mandatory = $true)]
			[string]$Username,
			
			[Parameter(ParameterSetName = 'UserPass',
					   Mandatory = $true)]
			[string]$Password,
			
			[ValidateSet('Cherwell', 'LDAP', IgnoreCase = $true)]
			[string]$AuthenticationSource = 'LDAP'
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		switch ($PsCmdlet.ParameterSetName) {
			'CredsObject' {
				$script:CherwellConfig.Credentials = $Credentials
				break
			}
			'UserPass' {
				$securePW = ConvertTo-SecureString $Password -AsPlainText -Force
				$script:CherwellConfig.Credentials = [System.Management.Automation.PSCredential]::new($Username, $securePW)
				break
			}
		}
		
		Set-CherwellAuthenticationSource -AuthenticationSource $AuthenticationSource
		
		$script:CherwellConfig.Credentials
	}
	
	function Get-CherwellCredentials {
		[CmdletBinding()]
		[OutputType([pscredential])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if (-not $script:CherwellConfig.Credentials) {
			throw "Cherwell Credentials not set! You may set with Set-CherwellCredentials"
		}
		
		$script:CherwellConfig.Credentials
	}
	
	function Set-CherwellAuthenticationSource {
		[CmdletBinding()]
		param (
			[ValidateSet('Internal', 'LDAP', IgnoreCase = $true)]
			[string]$AuthenticationSource = 'LDAP'
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$script:CherwellConfig.AuthenticationSource = $AuthenticationSource
		
		$script:CherwellConfig.AuthenticationSource
	}
	
	function Get-CherwellAuthenticationSource {
		[CmdletBinding()]
		[OutputType([string])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if (-not $script:CherwellConfig.AuthenticationSource) {
			throw "Cherwell Authentication Source not set! You may set with Set-CherwellAuthenticationSource"
		}
		
		$script:CherwellConfig.AuthenticationSource
	}
	
	function Set-CherwellAPIKey {
		[CmdletBinding()]
		param
		(
			[Parameter(Mandatory = $true)]
			[string]$APIKey
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$script:CherwellConfig.APIKey = $APIKey.Trim()
		$script:CherwellConfig.APIKey
	}
	
	function Get-CherwellAPIKey {
		[CmdletBinding()]
		[OutputType([string])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if ($script:CherwellConfig.APIKey -eq $null) {
			throw "Cherwell API Key is not set! You may set it with Set-CherwellAPIKey -APIKey 'key' or Connect-CherwellAPI"
		}
		
		$script:CherwellConfig.APIKey
	}
	
	function SetCherwellConfigToken {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true)]
			[pscustomobject]$Token
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		<# Typical token response
			{
			  "access_token": "REALLYLONGSTRING",
			  "token_type": "bearer",
			  "expires_in": 1199,
			  "refresh_token": "string",
			  "as:client_id": "client-id",
			  "username": "username",
			  ".issued": "Mon, 01 May 2017 15:33:19 GMT",
			  ".expires": "Mon, 01 May 2017 15:53:19 GMT"
			}
		#>
		
		# Convert some values to better types for easier manipulation
		Write-Verbose "Setting and converting token values to PS types"
		$script:CherwellConfig.Token = [pscustomobject]@{
			'AccessToken' = $Token.access_token
			'TokenType' = $Token.token_type
			'ExpiresIn' = $Token.expires_in
			'RefreshToken' = $Token.refresh_token
			'AsClientId' = $Token.'as:client_id'
			'Username' = $Token.Username
			'Issued' = [datetime]$Token.'.issued'
			'Expires' = [datetime]$Token.'.expires'		
		}
	}
	
	function GetCherwellConfigToken {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param ()
		
		if (-not $script:CherwellConfig.Token) {
			throw "Cherwell Token not set! You must connect to a Cherwell API to set the token!"
		}
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$script:CherwellConfig.Token
	}
	
	function Set-CherwellAutoRefreshTokenSetting {
		[CmdletBinding()]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[boolean]$Enabled
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$script:CherwellConfig.AutoRefreshToken = $Enabled
	}
	
	function Get-CherwellAutoRefreshTokenSetting {
		[CmdletBinding()]
		[OutputType([boolean])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if ($script:CherwellConfig.AutoRefreshToken -eq $null) {
			throw "Cherwell AutoRefreshToken is not set! You may set it with Set-CherwellAutoRefreshToken -Enabled [`$true|`$false]"
		}
		
		$script:CherwellConfig.AutoRefreshToken
	}
	
	function Set-CherwellAPITimeout {
	<#
		.SYNOPSIS
			Sets the timeout in seconds for the API calls
		
		.DESCRIPTION
			Sets the amount of time in seconds for which the API request will wait before timing out and returning an error
		
		.PARAMETER Seconds
			An integer representing seconds
		
		.EXAMPLE
			PS C:\> Set-CherwellAPITimeout -Seconds $value1
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[ValidateRange(1, 60)]
			[int32]$Seconds
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$script:CherwellConfig.Timeout = $Seconds
	}
	
	function Get-CherwellAPITimeout {
		[CmdletBinding()]
		[OutputType([int32])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		if ($script:CherwellConfig.Timeout -eq $null) {
			throw "Cherwell API timeout is not set! You may set it with Set-CherwellAPITimeout -Seconds [int32]"
		}
		
		$script:CherwellConfig.Timeout
	}
	
	function Get-CherwellToken {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param ()
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		$uri = BuildNewURI -Hostname (Get-CherwellHostname) -TokenRequest -Parameters @{
			'api_key' = (Get-CherwellAPIKey)
			'auth_mode' = (Get-CherwellAuthenticationSource)
		}
		
		$header = @{
			"Accept" = "application/json"
			"Content-Type" = "application/x-www-form-urlencoded"
		}
		
		# The body contains the client ID and the credentials for the call
		$body = @{
			"grant_type" = "password"
			"client_id" = (Get-CherwellAPIKey)
			"username" = (Get-CherwellCredentials).UserName
			"password" = (Get-CherwellCredentials).GetNetworkCredential().Password
		}
		
		return InvokeCherwellRequest -URI $uri -Headers $header -Body $body -Method POST -TokenRequest -ContentType application/x-www-form-urlencoded
	}
	
	function Connect-CherwellAPI {
	<#
		.SYNOPSIS
			Connect to a Cherwell API
		
		.DESCRIPTION
			Connect a session to a Cherwell API by obtaining a token and optionally pre-caching some data.
		
		.PARAMETER Hostname
			The DNS name of the Cherwell server hosting the API application
		
		.PARAMETER Credentials
			Credentials to access the Cherwell API. If not provided as a parameter, you will be prompted.
		
		.PARAMETER AuthenticationSource
			The source for which the credentials should be checked against. Defaults to LDAP
		
		.PARAMETER APIKey
			A valid API key created by a Cherwell Administrator. This key is not necessarily associated with a 
			particular user.
		
		.PARAMETER AutoRefreshToken
			When enabled, if the token has expired since first connecting, automatically submit the request to refresh the 
			token for another period of time. Default is enabled.
		
		.PARAMETER Timeout
			The timeout in seconds for the HTTP call to the Cherwell server. Sometimes token requests take a little longer 
			to generate. Defaults to 5 seconds.
		
		.PARAMETER InstantiateCache
			This will perform lookups for [BusinessObjects, SearchItems] and cache the information to the local session. If
			more cmdlets run which would normally contact the server, the local cache will be used instead. Aforementioned 
			cmdlets can be forced to reference the server by the -Force parameter.
		
		.EXAMPLE
			PS C:\> Connect-CherwellAPI -Hostname 'cherwell.mydomain.com' -APIKey 'some-guid-here'
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([boolean])]
		param
		(
			[Parameter(Mandatory = $true)]
			[string]$Hostname,
			
			[pscredential]$Credentials,
			
			[ValidateSet('Internal', 'LDAP', IgnoreCase = $true)]
			[string]$AuthenticationSource = 'LDAP',
			
			[Parameter(Mandatory = $true)]
			[string]$APIKey,
			
			[boolean]$AutoRefreshToken = $true,
			
			[int32]$Timeout = 10,
			
			[boolean]$InstantiateCache = $true
		)
		
		Write-Debug "$($PSCmdlet.MyInvocation.InvocationName) called"
		
		Write-Progress -Id 1 -Activity "Connecting to CherwellAPI at $Hostname" -PercentComplete 25 -CurrentOperation "Configuring environment"
		
		SetupCherwellConfigVariable
		
		if (-not $Credentials) {
			Write-Verbose "Credentials not provided..."
			
			if ($AuthenticationSource -eq 'Internal') {
				$credMessage = 'Enter INTERNAL credentials for Cherwell in cherwell\username format.'
			} else {
				$credMessage = "Enter $($AuthenticationSource.ToUpper()) credentials for Cherwell (domain\username)"
			}
			
			Write-Progress -Id 1 -Activity "Connecting to CherwellAPI at $Hostname" -PercentComplete 25 -CurrentOperation "Obtaining credentials"
			
			if (-not ($Credentials = Get-Credential -Message $credMessage)) {
				throw "Credentials are necessary to connect to a Cherwell API service."
			}
		}
		
		Write-Progress -Id 1 -Activity "Connecting to CherwellAPI at $Hostname" -PercentComplete 50
		
		$null = Set-CherwellHostName -Hostname $Hostname
		$null = Set-CherwellAuthenticationSource -AuthenticationSource $AuthenticationSource
		$null = Set-CherwellCredentials -Credentials $Credentials
		$null = Set-CherwellAPIKey -APIKey $APIKey
		$null = Set-CherwellAPITimeout -Seconds $Timeout
		$null = Set-CherwellAutoRefreshTokenSetting -Enabled $AutoRefreshToken
		
		# Try to obtain a token from the service
		try {
			Write-Progress -Id 1 -Activity "Connecting to CherwellAPI at $Hostname" -PercentComplete 75 -CurrentOperation "Obtaining token from Cherwell"
			$token = Get-CherwellToken -ErrorAction Stop
			SetCherwellConfigToken -Token $token
			
			Write-Progress -Id 1 -Activity "Connecting to CherwellAPI at $Hostname" -Completed
			
			$script:CherwellConfig.Connected = $true
			return $true
		} catch {
			if ($_.Response) {
				try {
					$result = $_.Exception.Response.GetResponseStream()
					$reader = New-Object System.IO.StreamReader($result)
					$reader.BaseStream.Position = 0
					$reader.DiscardBufferedData()
					$responseBody = $reader.ReadToEnd() | ConvertFrom-Json
					
					switch ($responseBody.error) {
						'invalid_grant' {
							throw "Invalid username/password provided"
							break
						}
						
						'invalid_client_id' {
							throw $responseBody.error_description
							break
						}
						
						default {
							throw $_
						}
					}
				} catch {
					throw $_
				}
			} else {
				throw $_
			}
		}
	}
	
	
	
	
	
	
	
	#endregion

#region Invoke-Searches_ps1
	<#	
		.NOTES
		===========================================================================
		 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2017 v5.4.138
		 Created on:   	5/3/2017 12:20 PM
		 Created by:   	 Ben Claussen
		 Organization: 	NEOnet
		 Filename:     	Searches.ps1
		===========================================================================
		.DESCRIPTION
			Functions related to Searches
	#>
	
	function Get-CherwellSearchItems {
	<#
		.SYNOPSIS
			Operation that returns a tree of saved queries, including scope, search name, IDs, and location within the tree
		
		.DESCRIPTION
			A detailed description of the Get-CherwellSearchItems function.
		
		.PARAMETER AssociationId
			Use to filter results by Business Object association ID. You can obtain the business object IDs through the
			Get-CherwellBusinessObject* cmdlets
		
		.PARAMETER Scope
			Use to filter results by scope name or ID. Defaults to Global
		
		.PARAMETER ScopeOwnerId
			Use to filter results by scope owner ID. Must be used with AssociationId and Scope.
		
		.PARAMETER FolderId
			Use to filter results by Search Group folder ID. Must be used with AssociationId, Scope, and ScopeOwner
		
		.PARAMETER IncludeLinks
			Switch to include hyperlinks in results. Default is false.
		
		.EXAMPLE
			PS C:\> Get-CherwellSearchItems
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(ValueFromPipelineByPropertyName = $true)]
			[Alias('busObId')]
			[string]$AssociationId,
			
			[ValidateSet('Global', 'User', 'Team', 'Role', 'Persona', IgnoreCase = $true)]
			[string]$Scope = 'Global',
			
			[string]$ScopeOwnerId,
			
			[string]$FolderId,
			
			[switch]$IncludeLinks
		)
		
		$Segments = [System.Collections.ArrayList]@('getsearchitems')
		
		if ($AssociationId) {
			if (-not (VerifyIDLength -Id $AssociationId)) {
				throw "Association Id is not a valid length."
			}
			
			$null = $Segments.AddRange(@('association', $AssociationId))
			
			if ($Scope) {
				$null = $Segments.AddRange(@('scope', $scope))
				
				if ($ScopeOwnerId) {
					if (-not (VerifyIDLength -Id $ScopeOwnerId)) {
						throw "ScopeOwnerId is not a valid length"
					}
					
					$null = $Segments.AddRange(@('scopeowner', $ScopeOwnerId))
					
					if ($FolderId) {
						if (-not (VerifyIDLength -Id $FolderId)) {
							throw "FolderId is not a valid length"
						}
						
						$null = $Segments.AddRange(@('folder', $FolderId))
					}
				}
			}
		}
		
		if ($IncludeLinks) {
			$uriParameters = @{
				"Links" = $IncludeLinks
			}
		}
		
		$uri = BuildNewURI -Segments $Segments -Parameters $uriParameters
		
		$searchItems = InvokeCherwellRequest -URI $uri
		
		if ($searchItems) {
			$searchItems.supportedAssociations = $searchItems.supportedAssociations | Sort-Object -Property 'busObName' -Unique
			$searchItems
		}
	}
	
	function Get-CherwellSearchResultsAdHoc {
	<#
		.SYNOPSIS
			Execute an adhoc search
		
		.DESCRIPTION
			Operation that runs an ad-hoc Business Object search. To execute a search with Prompts, the PromptId and Value are required in the Prompt request object
		
		.PARAMETER busObId
			The Business Object ID to execute the search against
		
		.PARAMETER Fields
			The RecIds of the fields to return
		
		.PARAMETER IncludeAllFields
			Include all fields in the returned data
		
		.PARAMETER PageSize
			Size of the return result. Defaults to maximum
		
		.PARAMETER PageNumber
			A description of the PageNumber parameter.
		
		.PARAMETER Timeout
			Time in seconds for which the API call will time out and return an error.
		
		.PARAMETER Filters
			A collection of FilterInfo data structures. A FilterInfo contains the full field ID, operator and value.
			You can specify more than one filter. If you add multiple filters for the same field ID, the result
			is an OR operation between those fields. If the field IDs are different, the result is an AND operation
			between those fields
			
			Valid values are
		
		.PARAMETER IncludeSchema
			Include the schema in the data
		
		.EXAMPLE
			PS C:\> Get-CherwellSearchResults
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipeline = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[Alias('BusinessObjectID')]
			[string[]]$busObId,
			
			[string[]]$Fields,
			
			[switch]$IncludeAllFields,
			
			[uint16]$PageSize = [uint16]::MaxValue,
			
			[uint32]$PageNumber,
			
			[int32]$Timeout,
			
			[hashtable[]]$Filters,
			
			[switch]$IncludeSchema
		)
		
		BEGIN {
			$uri = BuildNewURI -Segments 'getsearchresults'
			$body = @{
				'busObId' = $null
				"pageSize" = $PageSize
			}
			
			if ($PageSize) {
				$body.Add('pageNumber', $PageNumber)
			}
			
			if ($IncludeAllFields) {
				$body.Add('includeAllFields', $true)
			} elseif ($Fields) {
				$body.Add('fields', [System.Collections.ArrayList]::new())
				foreach ($field in $Fields) {
					$null = $body.Fields.Add($field)
				}
			}
			
			if ($Filters) {
				$body.Add('filters', [System.Collections.ArrayList]::new())
				foreach ($filter in $filters) {
					$null = $body.filters.add($filter)
				}
			}
			
			if ($IncludeSchema) {
				$body.Add('includeSchema', $true)
			}
			
			if (-not $Timeout) {
				$Timeout = Get-CherwellAPITimeout
			}
		}
		
		PROCESS {
			foreach ($id in $busObId) {
				$body.busObId = $id
				
				try {
					InvokeCherwellRequest -URI $uri -Body $body -Method POST -Timeout $Timeout
				} catch {
					if ($_.ErrorDetails.Message -match "The Business Object is not configured for searching") {
						$eSplat = @{
							'Message' = "The Business Object $id is not configured for searching."
							'Category' = $_.CategoryInfo.Category
							'CategoryActivity' = $_.CategoryInfo.Activity
							'CategoryReason' = $_.CategoryInfo.Reason
							'TargetObject' = $_.TargetObject
							'RecommendedAction' = "Configure the object $id for searching in Cherwell Administrator"
						}
						Write-Error @eSplat
					} else {
						Write-Error -ErrorRecord $_
					}
				}
			}
		}
		
		END {
			
		}
	}
	
	function Get-CherwellSearchResultsSavedSearch {
	<#
		.SYNOPSIS
			Retrieves a saved search results by name
		
		.DESCRIPTION
			A detailed description of the Get-CherwellSearchResultsByName function.
		
		.PARAMETER Association
			Specify the Business Object association ID for the saved search
		
		.PARAMETER Scope
			Specify the scope name or ID for the saved search
		
		.PARAMETER ScopeOwner
			Specify the scope owner ID for the saved search. Use (None) when no scope owner exists
		
		.PARAMETER SearchName
			Specify the name of the saved search
		
		.PARAMETER SearchId
			Specify the internal ID for the saved search. Use the "SearchName" parameter if you do not have the internal ID
		
		.PARAMETER SearchTerm
			Specify search text filter the results. Example: Use "Service Request" to filter Incident results to include only service requests
		
		.PARAMETER PageNumber
			Specify the page number of the result set to return
		
		.PARAMETER PageSize
			Specify the number of rows to return per page
		
		.PARAMETER IncludeSchema
			Use to include the table schema of the saved search. If false, results contain the fieldid and field value without field information. Default is false
		
		.PARAMETER ResultsAsSimpleList
			Indicates if the results should be returned in a simple results list format or a table format. Default is a table format
		
		.PARAMETER Timeout
			A description of the Timeout parameter.
		
		.EXAMPLE
			PS C:\> Get-CherwellSearchResultsByName
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding(DefaultParameterSetName = 'SearchId')]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$Association,
			
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$Scope,
			
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$ScopeOwner,
			
			[Parameter(ParameterSetName = 'SearchName',
					   Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$SearchName,
			
			[Parameter(ParameterSetName = 'SearchId',
					   Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$SearchId,
			
			[string]$SearchTerm,
			
			[uint32]$PageNumber,
			
			[uint32]$PageSize,
			
			[switch]$IncludeSchema,
			
			[switch]$ResultsAsSimpleList,
			
			[System.Nullable[int32]]$Timeout
		)
		
		BEGIN {
			$uriParameters = @{
			}
			
			if ($SearchTerm) {
				Write-Debug "Adding searchTerm parameter"
				$uriParameters.Add('searchTerm', $SearchTerm)
			}
			
			if ($PageNumber) {
				Write-Debug "Adding pageNumber parameter"
				$uriParameters.Add('pageNumber', $PageNumber)
			}
			
			if ($PageSize) {
				Write-Debug "Adding pageSize parameter"
				$uriParameters.Add('pageSize', $PageSize)
			}
			
			if ($IncludeSchema) {
				Write-Debug "Adding includeSchema parameter"
				$uriParameters.Add('includeSchema', 'true')
			}
			
			if ($ResultsAsSimpleList) {
				Write-Debug "Adding resultsAsSimpleList parameter"
				$uriParameters.Add('resultsAsSimpleList', 'true')
			}
			
			if ($Timeout -eq $null) {
				$Timeout = Get-CherwellAPITimeout
				Write-Verbose "Setting timeout to default: $Timeout"
			}
		}
		
		PROCESS {
			$Segments = [System.Collections.ArrayList]@('getsearchresults', 'association', $Association, 'scope', $Scope, 'scopeowner', $ScopeOwner)
			
			switch ($PSCmdlet.ParameterSetName) {
				'SearchId' {
					Write-Debug "Using parameter set $_"
					if (-not (VerifyIDLength -Id $SearchId)) {
						throw "ID is not a valid length"
					}
					$Segments.AddRange(@('searchid', $SearchId))
				}
				
				'SearchName' {
					Write-Debug "Using parameter set $_"
					$Segments.AddRange(@('searchname', $SearchName))
				}
			}
	
			$uri = BuildNewURI -Segments $Segments -Parameters $uriParameters
			
			InvokeCherwellRequest -URI $uri -Timeout $Timeout
		}
		
		END {
		}
	}
	
	
	function Convert-CherwellSearchResultsToArray {
		[CmdletBinding()]
		[OutputType([System.Collections.ArrayList])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true,
					   Position = 0)]
			[pscustomobject[]]$businessObjects
		)
		
		BEGIN {
			$list = [System.Collections.ArrayList]::new()
		}
		
		PROCESS {
			foreach ($obj in $businessObjects) {
				$listObject = @{}
				
				foreach ($field in $obj.fields) {
					$listObject[$field.Name] = $field.value
				}
				
				$null = $list.Add([pscustomobject]$listObject)
			}
		}
		
		END {
			,$list # Use comma to force System.Collections.ArrayList
		}
	}
	
	function New-CherwellSearchFilter {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[string]$FieldId,
			
			[Parameter(Mandatory = $true,
					   Position = 1)]
			[ValidateSet('Equal', 'eq', 'GreaterThan', 'gt', 'LessThan', 'lt', 'Contains', 'StartsWith', IgnoreCase = $true)]
			[string]$Operator,
			
			[Parameter(Mandatory = $true,
					   Position = 2)]
			[string]$Value
		)
		
		function ConvertOperator {
			[CmdletBinding()]
			[OutputType([string])]
			param
			(
				[Parameter(Mandatory = $true,
						   Position = 0)]
				[string]$Operator
			)
			
			switch -wildcard ($Operator) {
				"eq*" {
					return 'eq'
				}
				
				{ $_ -in "gt", "greaterthan" } {
					return 'gt'
				}
				
				{ $_ -in "lt", "lessthan" } {
					return "lt"
				}
				
				"contains" {
					return $_
				}
				
				"startswith" {
					return $_
				}
				
				default {
					throw "Unable to translate operator $_"
				}
			}
		}
		
		return @{
			'fieldId' = $FieldId
			'operator' = (ConvertOperator -Operator $Operator)
			'value' = $Value
		}
	}
	
	function New-CherwellSearchSort {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[string]$FieldId,
			
			[Parameter(Mandatory = $false,
					   Position = 1)]
			[ValidateSet('0', 'Descending', '1', 'Ascending', IgnoreCase = $true)]
			[string]$SortDirection = '0'
		)
		
		function ConvertSortDirection {
			[OutputType([byte])]
			param
			(
				[Parameter(Mandatory = $true,
						   Position = 0)]
				[string]$Direction
			)
			
			switch ($Direction) {
				{$_ -in "0", "Descending"} {
					return 0
				}
				
				{$_ -in "1", "Ascending"} {
					return 1
				}
				
				default {
					throw "Invalid sort direction provided"
				}
			}
		}
		
		return @{
			'fieldId' = $FieldId
			'sortDirection' = (ConvertSortDirection -Direction $SortDirection)
		}
	}
	
	
	
	
	
	
	#endregion

#region Invoke-BusinessObjects_ps1
	<#	
		.NOTES
		===========================================================================
		 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2017 v5.4.138
		 Created on:   	5/3/2017 12:34 PM
		 Created by:   	 Ben Claussen
		 Organization: 	NEOnet
		 Filename:     	BusinessObjects.ps1
		===========================================================================
		.DESCRIPTION
			A description of the file.
	#>
	
	function Get-CherwellBusinessObjectSummaryById {
	<#
		.SYNOPSIS
			Get a single Business Object's summary
		
		.DESCRIPTION
			Operation that returns a single Business Object summary by ID.
		
		.PARAMETER BusinessObjectId
			Specify a Business Object ID to get its summary
		
		.EXAMPLE
			PS C:\> Get-CherwellBusinessObjectSummaryById -BusinessObjectId 'Value1'
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[Alias('BusObId')]
			[string]$BusinessObjectId
		)
		
		$uri = BuildNewURI -Segments 'getbusinessobjectsummary', 'busobid', $BusinessObjectId
		
		return InvokeCherwellRequest -URI $uri
	}
	
	function Get-CherwellBusinessObjectSummaryByName {
	<#
		.SYNOPSIS
			Get a particular Business Objecy by the name
		
		.DESCRIPTION
			Operation that returns a single Business Object summary by name
		
		.PARAMETER BusinessObjectName
			Specify a Business Object name to get its summary
		
		.EXAMPLE
			PS C:\> Get-BusinessObjectSummaryByName -BusinessObjectName 'Value1'
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[Alias('BusObName')]
			[string]$BusinessObjectName
		)
		
		$uri = BuildNewURI -Segments 'getbusinessobjectsummary', 'busobname', $BusinessObjectName
		
		return InvokeCherwellRequest -URI $uri
	}
	
	function Get-CherwellBusinessObjectSummariesByType {
	<#
		.SYNOPSIS
			Get business object summaries by a particular type.
		
		.DESCRIPTION
			Operation that returns a list of Business Object summaries by type (Major, Supporting, Lookup, Groups, and All)..
		
		.PARAMETER Type
			Use to show:
			All - All objects (default)
			Major - Major objects only
			Supporting - Supporting objects only
			Lookup - Lookup objects only
			Groups - Groups only
		
		.PARAMETER Force
			Forces a refresh from the server instead of using the local cache
		
		.EXAMPLE
			PS C:\> Get-CherwellBusinessObjectSummariesByType
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		param
		(
			[ValidateSet('All', 'Major', 'Supporting', 'Lookup', 'Groups', IgnoreCase = $true)]
			[string]$Type = "All",
			
			[switch]$Force
		)
		
		$CachedSummaries = $script:CherwellConfig.CachedData.BusinessObjects.Summaries
		
		if ((-not $CachedSummaries) -or ($Force)) {
			Write-Verbose "Refreshing BusinessObjectSummaries from server and caching results"
			$uri = BuildNewURI -Segments 'getbusinessobjectsummaries', 'type', $Type
			
			$CachedSummaries = InvokeCherwellRequest -URI $uri
			
			$script:CherwellConfig.CachedData.BusinessObjects.Summaries = $CachedSummaries
		} else {
			Write-Verbose "Using cached BusinessObjectSummaries"
		}
		
		$CachedSummaries
	}
	
	function Find-CherwellBusinessObjectByDisplayName {
	<#
		.SYNOPSIS
			Search Cherwell business objects to find one by display name
		
		.DESCRIPTION
			This will obtain (by default) all business object summaries from Cherwell and filter the
			results to only those matching the DisplayName parameter. You may specify different match types.
		
		.PARAMETER DisplayName
			The display name of the business object to find.
		
		.PARAMETER MatchType
			Different methods of matching the display name. For example, if you choose 'Equal',
			only those business objects where the display name EQUALS your provided display name
			parameter will be returned. By default, this uses regular expression (powershell -match operator)
		
		.PARAMETER Type
			Only search a particular type of business objects. Default is "All"
		
		.PARAMETER Force
			Forces a refresh of the summary information from the server instead of pulling from cached data
		
		.EXAMPLE
			PS C:\> Find-CherwellBusinessObjectByDisplayName -DisplayName 'Contact'
			
			This will return all Business Objects where the display name MATCHES "contact" by regular expression.
		
		.EXAMPLE
			PS C:\> Find-CherwellBusinessObjectByDisplayName -DisplayName 'Contact' -MatchType 'Equal'
			
			This will return all Business Objects where the display name EQUALS "Contact".
		
		.EXAMPLE
			PS C:\> Find-CherwellBusinessObjectByDisplayName -DisplayName 'Contact' -MatchType 'Equal' -Type 'Supporting'
			
			This will return all Business Objects where the display name EQUALS "Contact", and ONLY 'Supporting' objects.
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject[]])]
		param
		(
			[Parameter(Mandatory = $true)]
			[string]$DisplayName,
			
			[ValidateSet('Match', 'Like', 'NotLike', 'Equal', 'NotEqual', 'StartsWith', IgnoreCase = $true)]
			[string]$MatchType = 'Match',
			
			[ValidateSet('All', 'Major', 'Supporting', 'Lookup', 'Groups', IgnoreCase = $true)]
			[string]$Type = "All",
			
			[switch]$Force
		)
		
		# Firstly, get the business object summaries by type
		$busObjSummaries = Get-CherwellBusinessObjectSummariesByType -Type $Type -Force:$Force.ToBool()
		
		# Loop through each one and output those whose displayname matches $DisplayName
		foreach ($businessObject in $busObjSummaries) {
			# Is this a group?
			if ($businessObject.group -eq $true) {
				foreach ($subBusinessObject in $businessObject.groupSummaries) {
					#if ($subBusinessObject.displayName -match $DisplayName) {
					if ((CompareValue $subBusinessObject.displayName $MatchType $DisplayName)) {
						Write-Output $subBusinessObject
					}
				}
			} else {
				#if ($businessObject.displayName -match $DisplayName) {
				if ((CompareValue $businessObject.displayName $MatchType $DisplayName)) {
					Write-Output $businessObject
				}
			}
		}
	}
	
	function Get-CherwellBusinessObjectSchema {
	<#
		.SYNOPSIS
			Returns the schema for a Business Object and, optionally, its related Business Objects
		
		.DESCRIPTION
			Returns the schema for a Business Object and, optionally, its related Business Objects
		
		.PARAMETER BusObId
			The object(s) returned from a Cherwell call to get a business object, or string(s).
		
		.PARAMETER IncludeRelationships
			Switch to include schemas for related Business Object
		
		.EXAMPLE
			PS C:\> Get-CherwellBusinessObjectSchema -BusObId $value1
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipeline = $true,
					   ValueFromPipelineByPropertyName = $true,
					   Position = 0)]
			[Alias('BusinessObjectId')]
			[object[]]$BusObId,
			
			[switch]$IncludeRelationships
		)
		
		Begin { }
		
		Process {
			foreach ($businessObject in $BusObId) {
				if ($IncludeRelationships) {
					$uriParameters = @{
						'includerelationships' = $true
					}
				}
				
				Write-Verbose "BusObId is $($businessObject.GetType().FullName)"
				
				if (($businessObject -is [pscustomobject]) -and ($businessObject.busObId)) {
					Write-Verbose 'BusObId property exists on BusObId'
					$id = $businessObject.busObId
				} else {
					Write-Verbose "BusObId property does not exist on BusObId"
					$id = $businessObject
				}
				
				if ((VerifyIDLength $id)) {
					$uri = BuildNewURI -Segments @('getbusinessobjectschema', 'busobid', $id) -Parameters $uriParameters
					
					InvokeCherwellRequest -URI $uri
				} else {
					Write-Error -Message "Id $id is not valid." -Category InvalidData -TargetObject $businessObject -RecommendedAction 'Check that the ID provided is correct'
				}
			}
		}
		
		End {
			
		}
	}
	
	function Find-CherwellFieldNameInSchemaByDisplayName {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true,
					   Position = 0)]
			[object[]]$FieldDefinitions,
			
			[Parameter(Position = 2)]
			[string]$DisplayName,
			
			[Parameter(Position = 1)]
			[ValidateSet('Match', 'Like', 'NotLike', 'Equal', 'NotEqual', 'StartsWith', IgnoreCase = $true)]
			[string]$MatchType = 'Match'
		)
		
		BEGIN {
			if ($PSCmdlet.MyInvocation.PipelineLength -gt 1) {
				Write-Verbose "In pipeline; Position $($PSCmdlet.MyInvocation.PipelinePosition); Length: $($PSCmdlet.MyInvocation.PipelineLength)"
				$InPipeline = $true
			} else {
				Write-Verbose "Not in pipeline"
				$InPipeline = $false
			}
		}
		
		PROCESS {
			foreach ($field in $FieldDefinitions) {
				if ((CompareValue $field.displayName $MatchType $DisplayName)) {
					Write-Output $field
				}
			}
		}
		
		END {
			
		}
	}
	
	function Get-CherwellBusinessObjectRecord {
	<#
		.SYNOPSIS
			Get a business object record
		
		.DESCRIPTION
			Operation that returns a Business Object record that includes a list of fields and their record IDs, names, and set values
		
		.PARAMETER busObId
			A description of the busObId parameter.
		
		.PARAMETER busObRecId
			A description of the busObRecId parameter.
		
		.PARAMETER busObPublicId
			A description of the busObPublicId parameter.
		
		.EXAMPLE
			PS C:\> Get-CherwellBusinessObjectRecord -busObId '42characterObjectId' -busObRecId '42characterRecId'
			PS C:\> Get-CherwellBusinessObjectRecord -busObId '42characterObjectId' -busObPublicId 'publicId'
		
		.OUTPUTS
			pscustomobject
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding(DefaultParameterSetName = 'RecId')]
		[OutputType([pscustomobject], ParameterSetName = 'RecId')]
		[OutputType([pscustomobject], ParameterSetName = 'PublicId')]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true)]
			[string]$busObId,
			
			[Parameter(ParameterSetName = 'RecId',
					   Mandatory = $true)]
			[string]$busObRecId,
			
			[Parameter(ParameterSetName = 'PublicId',
					   Mandatory = $true)]
			[string]$busObPublicId
		)
		
		switch ($PsCmdlet.ParameterSetName) {
			'RecId' {
				$uri = BuildNewURI -Segments 'busObId', $busObId, 'busObRecId', $busObRecId
				break
			}
			'PublicId' {
				$uri = BuildNewURI -Segments 'busObId', $busObId, 'publicid', $busObPublicId
				break
			}
		}
		
		InvokeCherwellRequest -URI $uri
	}
	
	
	function Get-CherwellBusinessObjectRecordBatch {
	<#
		.SYNOPSIS
			Obtain a batch of Business Object Records
		
		.DESCRIPTION
			Operation that returns a batch of Business Object records that includes a list of field record IDs, display names, and values for each record.
		
		.PARAMETER ReadRequests
			Specify an array of Business Object IDs, record IDs, or public IDs. Must be in format @{'busObId' = '<busobid>'}, etc...
		
		.PARAMETER StopOnError
			Flag to stop on error or continue on error. Defaults to continue on error
		
		.EXAMPLE
					PS C:\> Get-CherwellBusinessObjectRecordBatch -ReadRequests $value1
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   Position = 0)]
			[pscustomobject[]]$ReadRequests,
			
			[Parameter(Position = 1)]
			[switch]$StopOnError
		)
		
		$uri = BuildNewURI -Segments 'getbusinessobjectbatch'
		
		$body = @{
			'readRequests' = [System.Collections.ArrayList]::new($ReadRequests)
			'stopOnError' = $StopOnError.ToBool()
		}
		
		return InvokeCherwellRequest -URI $uri -Body $body -Method POST
	}
	
	function New-CherwellBusinessObjectRecordBatchReadRequest {
	<#
		.SYNOPSIS
			Create a new ReadRequest for a BusinessObject Batch request
		
		.DESCRIPTION
			Creates the appropriate request object for a batch record request
		
		.PARAMETER BusObId
			The business object ID
		
		.PARAMETER BusObPublicId
			The business object public ID
		
		.PARAMETER BusObRecId
			The business object record ID
		
		.EXAMPLE
			PS C:\> New-CherwellBusinessObjectBatchReadRequest -BusObId 'Value1'
		
		.OUTPUTS
			pscustomobject
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding(DefaultParameterSetName = 'BusObId')]
		[OutputType([pscustomobject], ParameterSetName = 'BusObId')]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(ParameterSetName = 'BusObId',
					   Mandatory = $true)]
			[string]$BusObId,
			
			[Parameter(ParameterSetName = 'BusObPublicId',
					   Mandatory = $true)]
			[string]$BusObPublicId,
			
			[Parameter(Mandatory = $true)]
			[string]$BusObRecId
		)
		
		$object = @{
			'busObRecId' = $BusObRecId
		}
		
		switch ($PsCmdlet.ParameterSetName) {
			'BusObId' {
				$object.Add('busObId', $BusObId)
				break
			}
			'BusObPublicId' {
				$object.Add('busObPublicId', $BusObPublicId)
				break
			}
		}
		
		return [pscustomobject]$object
	}
	
	function New-CherwellBusinessObjectRecord {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$busObId,
			
			[Parameter(Mandatory = $true)]
			[pscustomobject[]]$fields
		)
		
		Begin {
			$uri = BuildNewURI -Segments 'savebusinessobject'
		}
		
		Process {
			$body = @{
				'busObId' = $businessObject
				'fields' = $fields
			}
			
			InvokeCherwellRequest -URI $uri -Body $body -Method POST
		}
		
		End {
			
		}
	}
	
	function Update-CherwellBusinessObjectRecord {
	<#
		.SYNOPSIS
			Update an exising business object record
		
		.DESCRIPTION
			Operation that updates an existing Business Object. To update, specify record ID or public ID.
		
		.PARAMETER busObId
			A description of the busObId parameter.
		
		.PARAMETER busObRecId
			A description of the busObRecId parameter.
		
		.PARAMETER busObPublicId
			A description of the busObPublicId parameter.
		
		.PARAMETER fields
			A description of the fields parameter.
		
		.EXAMPLE
			PS C:\> Update-CherwellBusinessObjectRecord
		
		.OUTPUTS
			pscustomobject, pscustomobject
		
		.NOTES
			Additional information about the function.
	#>
		
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$busObId,
			
			[Parameter(ValueFromPipelineByPropertyName = $true)]
			[string]$busObRecId,
			
			[Parameter(ValueFromPipelineByPropertyName = $true)]
			[string]$busObPublicId,
			
			[Parameter(ValueFromPipelineByPropertyName = $true)]
			[pscustomobject[]]$Fields
		)
		
		BEGIN {
			$uri = BuildNewURI -Segments 'savebusinessobject'
		}
		
		PROCESS {
			$body = @{
				'busObId' = $busObId
				'fields' = $fields
			}
			
			if ($busObRecId) {
				Write-Verbose "Adding RecId for update"
				$body.Add('busObRecId', $busObRecId)
			} elseif ($busObPublicId) {
				Write-Verbose "Adding PublicId for update"
				$body.Add('busObPublicId', $busObPublicId)
			} else {
				Write-Error -Message "Did not find a RecId or PublicId on the object" -Category InvalidArgument -TargetObject $_
				continue
			}
			
			InvokeCherwellRequest -URI $uri -Body $body -Method POST
		}
		
		END {
			
		}
	}
	
	function Set-CherwellBusinessObjectRecordFieldValue {
		[CmdletBinding()]
		[OutputType([void])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipeline = $true,
					   Position = 0)]
			[pscustomobject]$Field,
			
			[Parameter(Mandatory = $true,
					   Position = 1)]
			[string]$NewValue
		)
		
		Begin {
			
		}
		
		Process {
			# Check there is a value and dirty property
			if (-not ($Field.psobject.properties.name -contains 'value')) {
				throw "'Value' property missing from field object"
			} elseif (-not ($Field.psobject.properties.name -contains 'dirty')) {
				throw "'Dirty' property missing from field object"
			}
			
			if ($Field.value -ne $NewValue) {
				Write-Verbose "Updating value"
				$Field.value = $NewValue
				$Field.dirty = $true
			} else {
				Write-Verbose "Value not changed"
			}
		}
		
		End {
			
		}
	}
	
	
	function New-CherwellBusinessObjectRecordField {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true)]
			[string]$displayName,
			
			[Parameter(Mandatory = $true)]
			[string]$fieldId,
			
			[Parameter(Mandatory = $true)]
			[string]$name,
			
			[Parameter(Mandatory = $true)]
			[string]$value
		)
		
		return @{
			'dirty' = $true
			'displayName' = $displayName
			'fieldId' = $fieldId
			'name' = $name
			'value' = $value
		}
	}
	
	function Get-CherwellBusinessObjectTemplate {
		[CmdletBinding(DefaultParameterSetName = 'RequiredFields')]
		[OutputType([pscustomobject], ParameterSetName = 'RequiredFields')]
		[OutputType([pscustomobject], ParameterSetName = 'SpecificFields')]
		[OutputType([pscustomobject], ParameterSetName = 'AllFields')]
		[OutputType([pscustomobject])]
		param
		(
			[Parameter(Mandatory = $true,
					   ValueFromPipelineByPropertyName = $true)]
			[string]$busObId,
			
			[Parameter(ParameterSetName = 'SpecificFields',
					   Mandatory = $true)]
			[string[]]$FieldNames,
			
			[Parameter(ParameterSetName = 'AllFields')]
			[switch]$IncludeAllFields,
			
			[Parameter(ParameterSetName = 'RequiredFields')]
			[switch]$IncludeRequiredFields
		)
		
		$uri = BuildNewURI -Segments 'getbusinessobjecttemplate'
		
		$body = @{
			'busObId' = $busObId
		}
		
		switch ($PsCmdlet.ParameterSetName) {
			'SpecificFields' {
				$body.Add('fieldNames', [System.Collections.ArrayList]::new($FieldNames))
				break
			}
			'AllFields' {
				$body.Add('includeAll', $true)
				break
			}
			'RequiredFields' {
				$body.Add('includeRequired', $true)
				break
			}
		}
		
		InvokeCherwellRequest -URI $uri -Body $body -Method POST
	}
	
	
	
	
	
	
	
	
	#endregion

#region Invoke-Core_ps1
	<#	
		.NOTES
		===========================================================================
		 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2018 v5.5.148
		 Created on:   	3/14/2018 3:12 PM
		 Created by:   	 Ben Claussen
		 Organization: 	NEOnet
		 Filename:     	Core.ps1
		===========================================================================
		.DESCRIPTION
			A description of the file.
	#>
	
	function Get-CherwellStoredValues {
		[CmdletBinding()]
		[OutputType([pscustomobject])]
		param
		(
			[ValidateSet('Global', 'User', 'Team', 'Role', 'Persona', IgnoreCase = $true)]
			[string]$Scope,
			
			[string]$ScopeOwnerId,
			
			[string]$FolderId,
			
			[switch]$IncludeLinks
		)
		
		$Segments = [System.Collections.ArrayList]@('storedvalues')
		
		if ($Scope) {
			$null = $Segments.AddRange(@('scope', $scope))
			
			if ($ScopeOwnerId) {
				if (-not (VerifyIDLength -Id $ScopeOwnerId)) {
					throw "ScopeOwnerId is not a valid length"
				}
				
				$null = $Segments.AddRange(@('scopeowner', $ScopeOwnerId))
				
				if ($FolderId) {
					if (-not (VerifyIDLength -Id $FolderId)) {
						throw "FolderId is not a valid length"
					}
					
					$null = $Segments.AddRange(@('folder', $FolderId))
				}
			}
		}
		
		if ($IncludeLinks) {
			$uriParameters = @{
				"Links" = $IncludeLinks
			}
		}
		
		$uri = BuildNewURI -Segments $Segments -Parameters $uriParameters
		
		$searchItems = InvokeCherwellRequest -URI $uri
		
	#	if ($searchItems) {
	#		$searchItems.supportedAssociations = $searchItems.supportedAssociations | Sort-Object -Property 'busObName' -Unique
	#		$searchItems
	#	}
	}#endregion

<#	
	===========================================================================
	 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2017 v5.4.135
	 Created on:   	3/27/2017 2:42 PM
	 Created by:   	 Ben Claussen
	 Organization: 	NEOnet
	 Filename:     	CherwellAPI.psm1
	-------------------------------------------------------------------------
	 Module Name: CherwellAPI
	===========================================================================
#>

#Export-ModuleMember "*-*"
Export-ModuleMember "*"


























